

/* external function definitions.                */

/* in file bliksem.c */

extern void errorwithline ( char* );
extern void errorwithoutline ( char* ); 
extern void internalproblem( char* );
extern void printclause( bliksemfile*, int );
extern void printclauselist( bliksemfile*, int );

/* file inoutput.m */

extern void printnametable( bliksemfile* );
extern void printstring( bliksemfile*, char* );
extern void printstringnnl( bliksemfile*, char* );
extern void printterm( bliksemfile*, int );
extern void printint( bliksemfile*, int );
extern void printhex( bliksemfile*, int );
extern void printvariable( bliksemfile*, int ); 
extern void printtermlist( bliksemfile*, char*, int, int ); 
extern void printoperator( bliksemfile*, int ); 
extern void initinoutput( int, char* [] );
extern int parser( void );


/* file objects.c    */

extern int makename( char* );
extern int makefreshname( char* );
extern int makeuseroperator( int, int ); 
extern int makefreshoperator( int, int );

extern char* operatorstring( int ); 
extern int isprologvar( int ); 
extern int isname( int ); 
extern int countterms( int ); 
extern void maketermends( int, int ); 
extern void inserttermspace( int, int );
extern void deletetermspace( int, int ); 
extern void exchangearguments( int ); 
extern void insertoperator( int, int );
extern int copyterm( int ); 
extern int termequal( int, int ); 
extern int replaceposition( int, int, int );
extern int fovarfree( int, int );
extern int fosubst( int, int, int ); 
extern void printstatistics( bliksemfile* ); 
extern void printtype ( bliksemfile*, int );
extern int hastype( int, int ); 


/* file orders.c */


extern int clausedepth( int );
extern int termvardepth( int );
extern int clauseweight( int );
extern int termnrvars( int );
extern int clausenrvars( int );
extern int termcompare( int, int );
extern int literalcompare( int, int );
extern int negselect( int, int );
extern int posselect( int, int );

/* file subsumption.c */

extern int subsumes( int, int ); 
extern void makefilter( int );
extern int forwardsubsumed( int ); 
extern int backwardsubsumed( int );
extern void dt_subs( int, int );


/* file simplify.c */

extern int literalsistautology( );
extern void selfreduceliterals( int );
extern void simpfacteqrefl( int );
extern int simpdemod( int, int, int );
extern int simpreso( int, int, int );
extern void dt_demod( int, int );
extern void dt_simpres( int, int );


/* file conversion.c  */

extern int makeconversion( int, int, int );
extern void printjustconv( bliksemfile*, int );


/* file rules.c       */

extern int mainloop ( int, int ); 

/* file unify.c       */

extern int unify( int, int, int, int );
extern int ressubst( int, int ); 
extern int match( int, int );
extern int matchsubst( int );

extern void printtree( bliksemfile*, int );
extern void addtotree( int*, int, int, int );
extern void deletefromtree( int*, int, int, int );
extern void retrievefromtree( int, int, void( int, int, int )); 
extern void retrievefromtreeeqrewr( int, int, void( int, int, int )); 

/* file proofcheck.c  */

extern void checkproof( int, int, int );

