/* code gegenereerd door Maphoon 3.2 */
/* C. Hans de Nivelle, sept 1989     */


#define ERRORIS(X) ma_errortel = X
#define ERROK      ma_errortel = 0
#define ACCEPTEER  longjmp ( ma_accepteer, 1)
#define ERROR      longjmp ( ma_errret, 1);

#define MA_ACCACT       - 16384
#define MA_ERRACT       - 16385
#define MA_DEFACT       - 16386

#define CODERROR     -1
#define CODEIND      -2
#define CODDEF       -3
#define CODNIL       -20000

#line 2 "inoutput.m" 
/********************************************************/
/* File inoutput.m                                      */
/* part of bliksem.                                     */
/********************************************************/


#define CLASS extern
#include "basics.h" 
#include "tokens.h"
#include "extfunc.h"



/**********************************************************************/
/* This is the scanner of the bliksem theorem prover.                 */
/* It is able to recognize the following tokens:                      */
/* 1. comments starting with / * and ending with * / (without space)  */
/* 2. variables consisting of letters, digits, and _?$%               */
/* 3. Tokens from the list tokenlist.                                 */
/* 4. EOF.                                                            */
/**********************************************************************/


/* The tokens are alfabetically sorted by function inittokens.    */

#define MAXTOKENS        50 
#define MAXTOKENSTRING   10
static struct 
{
char string [ MAXTOKENSTRING ];
int code; 
}
tokenlist [ MAXTOKENS ];
static int freetokenlist; 


/* The entries of the tokens starting with a given letter.    */
/* This array is meaningful because the tokens are sorted.    */
/* If first and sup < 0, then there are no tokens starting    */
/* with the given letter.                                     */

static struct
{
int first;
int sup;
}
tokenentries [ 128 ];


/* used to recognize the start of a comment: */
#define BLABLA  (-1)



/* add a token into the token list. */

static void maketoken ( s, nr )
char *s;
int nr; 
{
(void) strcpy( tokenlist [ freetokenlist ]. string, s );
tokenlist [ freetokenlist ]. code = nr;
freetokenlist ++ ;
if( freetokenlist >= MAXTOKENS - 3 )
internalproblem( "increase MAXTOKENS" );
}

/* The token table. Tokens can be added here.   */ 

static void maketokens ( )
{
freetokenlist = 0;

maketoken( "<", TOK_LESS );
maketoken( ">", TOK_GREATER );
maketoken( "[", TOK_LSQBRACKET );
maketoken( "]", TOK_RSQBRACKET );
maketoken( "(", TOK_LPAR );
maketoken( ")", TOK_RPAR );
maketoken( "{", TOK_LBRACKET );
maketoken( "}", TOK_RBRACKET );

maketoken( "<>", TOK_POSSIBLE );
maketoken( "[]", TOK_NECESSARY );

maketoken( ",",   TOK_COMMA );
maketoken( ".",   TOK_DOT );
maketoken( "<->", TOK_EQUIV );
maketoken( "->",  TOK_IMPLIES );
maketoken( "|",   TOK_OR );
maketoken( "&",   TOK_AND );
maketoken( "!",   TOK_NOT );
maketoken( "||",  TOK_FALSE );
maketoken( "&&",  TOK_TRUE );

maketoken( "=",    TOK_EQUAL );
maketoken( "==>",  TOK_REWRITES );
maketoken( "==",   TOK_EQUALEQUAL );
maketoken( "!=",   TOK_NOTEQUAL );
maketoken( "!==",  TOK_NOTEQUALEQUAL );
maketoken( "<=",   TOK_LESSEQUAL );
maketoken( ">=",   TOK_GREATEREQUAL );
maketoken( ">>",   TOK_GREATERGREATER );
maketoken( "<<",   TOK_LESSLESS );
maketoken( ">>=",  TOK_GREATERGREATEREQUAL );
maketoken( "<<=",  TOK_LESSLESSEQUAL );
maketoken( ">>==", TOK_GREATERGREATEREQUALEQUAL );
maketoken( "<<==", TOK_LESSLESSEQUALEQUAL );
maketoken( ":",    TOK_IN );

maketoken( "+", TOK_PLUS );
maketoken( "-", TOK_MINUS );
maketoken( "*", TOK_TIMES );
maketoken( "/", TOK_DIVIDES );
maketoken( "^", TOK_POW );

maketoken( "{}", TOK_NIL ); 

maketoken( "/*", BLABLA );
}


static void initoperators () 
{
int i;

arities [ OP_NIL ] = 0;
arities [ OP_DOT ] = 2;

arities [ OP_FALSE ] =    0;
arities [ OP_TRUE ] =     0;
arities [ OP_NOT ] =      1; 
arities [ OP_AND ] =      2; 
arities [ OP_OR ] =       2; 
arities [ OP_IMPLIES ] =  2; 
arities [ OP_EQUIV ] =    2; 

arities [ OP_FORALL ] = 2;
arities [ OP_EXISTS ] = 2;
arities [ OP_NECESSARY ] = 1;
arities [ OP_POSSIBLE ] = 1;

arities [ OP_EQUAL ] = 2;
arities [ OP_REWRITES ] = 2;

arities [ OP_LESS ] = 2;
arities [ OP_GREATER ] = 2;
arities [ OP_EQUALEQUAL ] = 2; 
arities [ OP_LESSEQUAL ] = 2;
arities [ OP_GREATEREQUAL ] = 2;
arities [ OP_GREATERGREATER ] = 2; 
arities [ OP_LESSLESS ] = 2;
arities [ OP_GREATERGREATEREQUAL ] = 2;
arities [ OP_LESSLESSEQUAL ] =       2;
arities [ OP_GREATERGREATEREQUALEQUAL ] = 2;
arities [ OP_LESSLESSEQUALEQUAL ] = 2;
arities [ OP_IN ] = 2;   /* In the end not used for sets. */ 

arities [ OP_PLUS ] = 2;
arities [ OP_MINUS ] = 2;
arities [ OP_TIMES ] = 2;
arities [ OP_DIVIDES ] = 2;
arities [ OP_POW ] = 2;

arities [ OP_UNARYMINUS ] = 1;
arities [ OP_UNARYPLUS ] = 1;

for( i = 0; i < OP_NONPRIMITIVE; i ++ ) 
{
operators [i]. flags = 0;
}

freeoperators = OP_NONPRIMITIVE;
}
#line 180 "inoutput.m" 
/*******************************************************************/
/*          Functions for preparing the tokenlist.                 */
/*******************************************************************/

/* s1 < s2 if its first letter is smaller, or if the first letters */
/* are equal, and the length of s1 is less than the length of s2.  */

static int tokenless ( s1, s2 )
char *s1;
char *s2; 
{
if( s1 [0] == 0 )
exit(0);
if( s2 [0] == 0 )
exit(0);

if( s1 [0] < s2 [0] )
return 1;
if( s1 [0] > s2 [0] )
return 0;

while( s1 [0] != 0 )
{
if( s2 [0] == 0 )
return 0;
s1 ++ ; s2 ++ ; 
}
if( s2 [0] != 0 ) 
return 1;
return 0;
}



static void inittokens ( )
{
int i;
char s [ MAXTOKENSTRING ];
int c;

maketokens ( ); 
/* sort tokenlist. */ 
restart:
for( i = 0; i < freetokenlist - 1; i ++ ) 
{
if( tokenless ( tokenlist [ i + 1 ]. string, 
tokenlist [ i ]. string ))
{
(void) strcpy( s, tokenlist [ i ]. string );
(void) strcpy( tokenlist [ i ]. string,
tokenlist [ i + 1 ]. string );
(void) strcpy( tokenlist [ i + 1 ]. string, s );             

c = tokenlist [ i ]. code;
tokenlist [ i ]. code = tokenlist [ i + 1 ]. code;
tokenlist [ i + 1 ].code = c;
goto restart;
}
}

for( i = 0; i < 128; i ++ ) 
{
tokenentries [i]. first = -1;
tokenentries [i]. sup = -1;
}

i = 0;
while( i < freetokenlist )
{
c = tokenlist [i]. string [0];
tokenentries [c]. first = i;
i ++ ; 
while( i < freetokenlist && 
tokenlist [i]. string [0] ==
tokenlist [ i - 1 ]. string [0] )
{
i ++ ; 
}
tokenentries [c]. sup = i; 
}

#if 0
for( i = 0; i < freetokenlist; i ++ ) 
{
printf("%d: %s    %d\n", tokenlist [i]. string [0], 
tokenlist [i]. string,
tokenlist [i]. code );
}
for( i = 0; i < 128; i ++ ) 
{
if( tokenentries [i]. first >= 0 )
printf("[%d: %d, %d]\n", i, 
tokenentries [i]. first,
tokenentries [i]. sup );
}
#endif
}



/********************************************************************/
/*         The scanner.                                             */
/********************************************************************/

static bliksemfile *scanfile;
extern int attribute; 

int syntaxerror( )
{
errorwithline( "syntax error" );
return 0;
}


static void readcharacter( f )
bliksemfile *f;
{
if( f -> rw != FILE_READ )
{
errorwithoutline( "file not open for reading!" );
}

if( f -> lookahead == EOF )
return ;

( f -> lookahead ) = getc ( f -> handle );
if( f -> lookahead == '\n' )
{
( f -> linenum ) ++ ;
( f -> linepos ) = 0;
}
else
( f -> linepos ) ++ ;
}


static int allowedinname ( x )
int x;
{
if( x >= 'a' && x <= 'z' )
return 1;
if( x >= 'A' && x <= 'Z' )
return 1;
if( x >= '0' && x <= '9' )
return 1;
if( x == '_' || x == '?' || 
x == '$' || x == '%' )
return 1;
return 0;
}

/* read an unquoted name: */

static void scanunquotedname ( f ) 
bliksemfile *f;
{
char s [ MAXNAMELEN ];
int i;

i = 0;
while( allowedinname ( f -> lookahead )) 
{
s[i] = ( f -> lookahead );
i ++ ; 
if( i >= MAXNAMELEN - 3 )
errorwithline( "name is too long" );
readcharacter( f ); 
}
s[i] = 0;
attribute = makename ( s ); 
}


/* read a quoted name. (")     */

static void scanquotedname( f )
bliksemfile *f;
{
char s [ MAXNAMELEN ];
int i;

readcharacter(f);

i = 0;
while( (f -> lookahead) != EOF && 
(f -> lookahead) != '\n'  &&
(f -> lookahead) != '\"' )
{
s[i] = ( f -> lookahead );
i ++ ; 
if( i >= MAXNAMELEN - 3 )
errorwithline( "name is too long" );
readcharacter(f);
}
if( ( f -> lookahead ) != '\"' )
errorwithline( "newline or EOF in string" ); 
readcharacter(f); 
s[i] = 0;
attribute = makename( s );
}


/* return 1 if s1 is an initial string of s2. */ 

static int initialstring( s1, s2 )
char *s1;
char *s2;
{
while( *s1 != 0 )
{
if( *s1 != *s2 )
return 0;
s1 ++ ; s2 ++ ; 
}
return 1;
}

/* try to scan a special token from tokenlist [].  */ 

static int scanspecialtoken( f )
bliksemfile *f;
{
char s[ MAXTOKENSTRING + 2 ];

int i; 
int start, end;
int length;

start = tokenentries [ f -> lookahead ]. first; 
end = tokenentries [ f -> lookahead ]. sup;

s[0] = (f -> lookahead);
s[1] = 0;
length = 1;

next:
readcharacter(f);
s [ length ++ ] = ( f -> lookahead );
s [ length ] = 0;

#if 0 
printf("trying [%s] ", s ); 
#endif
for( i = start; i < end; i ++ ) 
{
if( initialstring( s, tokenlist [i]. string ))
{
start = i;
goto next;
} 
}

length -- ;
s [ length ] = 0;
#if 0
printf("we decide [%s]\n", s );
#endif    
for( i = start; i < end; i ++ ) 
{
if( strcmp( s, tokenlist [i]. string ) == 0 )
return tokenlist [i]. code;
}

errorwithline( "scanner error" );
return 0; 
}


/* scan a comment. The initial / * has already been read. */ 

static void scancomment ( f )
bliksemfile *f;
{
while( 1 )
{
while( (f -> lookahead) != EOF && 
(f -> lookahead) != '*' )
{
readcharacter(f); 
}
if( (f -> lookahead) == EOF ) 
errorwithline( "end of file in comment" );
readcharacter(f);

if( (f -> lookahead) == '/' )
{
readcharacter(f); 
return;
}
if( (f -> lookahead) == EOF )
errorwithline( "end of file in comment" );
}
}


/***********************************************************/
/*        read a token from the input.                     */ 
/***********************************************************/


int scanner ( ) 
{
int a;

aftercomment: 
if( scanfile -> lookahead == ' ' ||
scanfile -> lookahead == '\n' || 
scanfile -> lookahead == '\t' )
{
readcharacter( scanfile );
goto aftercomment; 
}

/* This type of comment has been added for the tptp2X utility. */

if( scanfile -> lookahead == '#' )
{
while( scanfile -> lookahead != '\n' &&
scanfile -> lookahead != EOF ) 
{
readcharacter( scanfile );
}
if( scanfile -> lookahead == EOF ) 
{
errorwithline( "end of file in comment" );
}
readcharacter( scanfile );
goto aftercomment; 
}

attribute = 0;  

if( (scanfile -> lookahead) == EOF )
return TOK_EOF;

if( (scanfile -> lookahead) >= 0X80 || 
(scanfile -> lookahead) < 0 )
errorwithline( "non-ascii character in input" );

if( allowedinname( scanfile -> lookahead ))
{
scanunquotedname ( scanfile );
return TOK_NAME;
}

if( (scanfile -> lookahead ) == '\"' )
{
scanquotedname( scanfile );
return TOK_NAME;
}

if( tokenentries [ scanfile -> lookahead ]. first >= 0 )
{
a = scanspecialtoken( scanfile );
if( a == BLABLA )
{
scancomment( scanfile );
goto aftercomment; 
}
return a; 
}
errorwithline( "garbage in input" ); 
}


/**************************************************************/
/*           Maphoon declarations:                            */
/**************************************************************/ 

#define MA_PARSE parser
#define MA_SCAN scanner
#define MA_ERR syntaxerror
#define MA_ATTR attribute
#define MA_STYPE int
#define MA_REDVOORUIT 1


/* de defines vooral */

#ifndef MA_STACK
#define MA_STACK 100
#endif

#ifndef MA_MAXERROR
#define MA_MAXERROR 20
#endif


extern int ma_regelnum [];
extern int ma_linkerk [];
extern int ma_rklengtes [];
extern int ma_acties [];
extern int ma_toestind [];
extern int ma_link [];
extern int ma_def [];
extern int ma_tekencodes [];
extern int ma_bepactie ();
extern void ma_code ();

int ma_lookahead;
MA_STYPE ma_attr [ MA_STACK ], MA_ATTR;
int ma_toest [ MA_STACK ];
int ma_toestsp;

jmp_buf ma_errret;
jmp_buf ma_accepteer;

int MA_PARSE ()
{
   int ma_actie, ma_regel;
   int ma_errortel;
   int ma_rkantlen;
   MA_STYPE ma_nieuw, * ma_tos;

#line 584 "inoutput.m" 
int n; 
int op;

   ma_errortel = 0;
   ma_toest [0] = 0;
   ma_toestsp = 1;

   if ( setjmp ( ma_errret )) goto ma_eeee;
   if ( setjmp ( ma_accepteer )) return (0);

   ma_lookahead = CODNIL;

   while (1)
   {
      ma_actie = ma_bepactie ( ma_toest [ma_toestsp - 1],
                               & ma_lookahead );
      if ( ma_actie == MA_ACCACT ) ACCEPTEER;
      if ( ma_actie > 0 && ma_actie != MA_ERRACT )
      {
         /* shift */
         ma_toest [ ma_toestsp ] = ma_actie;
         ma_attr [ ma_toestsp ++ ] = MA_ATTR;
#ifdef MA_DEBUG
         printf ("shift %d, ", ma_actie );
#endif
         if ( ma_toestsp >= MA_STACK - 1)
            goto ma_stackoverfl;
         ma_lookahead = CODNIL;
         if ( ma_errortel > 0 ) ma_errortel --;
      }
      else
      {
         if ( ma_actie != MA_ERRACT )
         {
            /* reductie */
            ma_regel = - ma_actie;
            ma_rkantlen = ma_rklengtes [ ma_regel ];
            ma_toestsp -= ma_rkantlen;
            ma_tos = ma_attr + ma_toestsp;
            ma_nieuw = ma_tos [0];   /* default-actie */
#ifdef MA_DEBUG
            printf ("red %d, tot S%d, ",
               ma_regelnum [ ma_regel], ma_toest [ ma_toestsp - 1 ] );
#endif
            switch ( ma_regelnum [ ma_regel ] )
            {
case 2:
#line 588 "inoutput.m"
return 0;
break;
case 6:
#line 602 "inoutput.m"
ma_nieuw = ma_tos [1];
insertoperator( OP_UNARYMINUS, ma_tos [1] );
break;
case 7:
#line 607 "inoutput.m"
ma_nieuw = ma_tos [1];
insertoperator( OP_UNARYPLUS, ma_tos [1] );
break;
case 8:
#line 613 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_POW, ma_tos [0] );
break;
case 9:
#line 619 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_TIMES, ma_tos [0] );
break;
case 10:
#line 624 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_DIVIDES, ma_tos [0] );
break;
case 11:
#line 630 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_PLUS, ma_tos [0] );
break;
case 12:
#line 635 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_MINUS, ma_tos [0] );
break;
case 13:
#line 641 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_EQUAL, ma_tos [0] ); 
break;
case 14:
#line 646 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_REWRITES, ma_tos [0] );
break;
case 15:
#line 651 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_LESS, ma_tos [0] );
break;
case 16:
#line 656 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_GREATER, ma_tos [0] );
break;
case 17:
#line 661 "inoutput.m"
ma_nieuw = ma_tos [0]; 
insertoperator( OP_EQUALEQUAL, ma_tos [0] );
break;
case 18:
#line 666 "inoutput.m"
ma_nieuw = ma_tos [0]; 
insertoperator( OP_EQUAL, ma_tos [0] );
insertoperator( OP_NOT, ma_tos [0] );
break;
case 19:
#line 672 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_EQUALEQUAL, ma_tos [0] );
insertoperator( OP_NOT, ma_tos [0] );
break;
case 20:
#line 678 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_LESSEQUAL, ma_tos [0] );
break;
case 21:
#line 683 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_GREATEREQUAL, ma_tos [0] );
break;
case 22:
#line 688 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_GREATERGREATER, ma_tos [0] );
break;
case 23:
#line 693 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_LESSLESS, ma_tos [0] );
break;
case 24:
#line 698 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_GREATERGREATEREQUAL, ma_tos [0] );
break;
case 25:
#line 703 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_LESSLESSEQUAL, ma_tos [0] );
break;
case 26:
#line 708 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_GREATERGREATEREQUALEQUAL, ma_tos [0] ); 
break;
case 27:
#line 713 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_LESSLESSEQUALEQUAL, ma_tos [0] );
break;
case 28:
#line 718 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_IN, ma_tos [0] );
break;
case 29:
#line 724 "inoutput.m"
ma_nieuw = ma_tos [1];
insertoperator( OP_NOT, ma_tos [1] );    
break;
case 30:
#line 730 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_AND, ma_tos [0] ); 
break;
case 31:
#line 736 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_OR, ma_tos [0] );
break;
case 32:
#line 742 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_EQUIV, ma_tos [0] );
break;
case 33:
#line 748 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_IMPLIES, ma_tos [0] ); 
break;
case 34:
#line 754 "inoutput.m"
ma_nieuw = ma_tos [1];
insertoperator( OP_POSSIBLE, ma_tos [1] );
break;
case 35:
#line 759 "inoutput.m"
ma_nieuw = ma_tos [1];
insertoperator( OP_NECESSARY, ma_tos [1] );
break;
case 36:
#line 764 "inoutput.m"
ma_nieuw = ma_tos [1];
break;
case 37:
#line 768 "inoutput.m"
ma_nieuw = ma_tos [1];
break;
case 38:
#line 774 "inoutput.m"
ma_nieuw = ma_tos [1]; 
break;
case 39:
#line 778 "inoutput.m"
ma_nieuw = freetermspace;
insertoperator( OP_NIL, freetermspace );
break;
case 40:
#line 783 "inoutput.m"
ma_nieuw = ma_tos [1];
break;
case 41:
#line 787 "inoutput.m"
ma_nieuw = freetermspace; 
op = makeuseroperator( ma_tos [0], 0 );
insertoperator( op, freetermspace ); 
break;
case 42:
#line 793 "inoutput.m"
n = countterms( ma_tos [2] );
op = makeuseroperator( ma_tos [0], n );
ma_nieuw = ma_tos [2];
insertoperator( op, ma_tos [2] );
break;
case 43:
#line 800 "inoutput.m"
ma_nieuw = freetermspace;
insertoperator( OP_TRUE, freetermspace );
break;
case 44:
#line 805 "inoutput.m"
ma_nieuw = freetermspace;
insertoperator( OP_FALSE, freetermspace ); 
break;
case 45:
#line 813 "inoutput.m"
ma_nieuw = freetermspace;  
op = makeuseroperator( ma_tos [0], 0 );
insertoperator( op, freetermspace ); 
insertoperator( OP_FORALL, ma_nieuw );
break;
case 46:
#line 820 "inoutput.m"
op = makeuseroperator( ma_tos [0], 0 );
ma_nieuw = ma_tos [2];
insertoperator( op, ma_tos [2] ); 
insertoperator( OP_FORALL, ma_tos [2] ); 
break;
case 47:
#line 829 "inoutput.m"
ma_nieuw = freetermspace;
op = makeuseroperator( ma_tos [0], 0 );
insertoperator( op, freetermspace );
insertoperator( OP_EXISTS, ma_nieuw );
break;
case 48:
#line 836 "inoutput.m"
op = makeuseroperator( ma_tos [0], 0 );
ma_nieuw = ma_tos [2];
insertoperator( op, ma_tos [2] );
insertoperator( OP_EXISTS, ma_tos [2] );
break;
case 49:
#line 845 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_NIL, freetermspace );
insertoperator( OP_DOT, ma_nieuw ); 
break;
case 50:
#line 851 "inoutput.m"
ma_nieuw = ma_tos [0];
insertoperator( OP_DOT, ma_tos [0] );
break;
case 51:
#line 857 "inoutput.m"
ma_nieuw = ma_tos [0]; 
break;
case 52:
#line 859 "inoutput.m"
ma_nieuw = ma_tos [0]; 
break;

default:
	 ;
            }

            ma_actie = ma_bepactie ( ma_toest [ ma_toestsp - 1],
                                     ma_linkerk + ma_regel );
#ifdef MA_DEBUG
            printf ("goto %d\n", ma_actie );
#endif
            ma_attr [ ma_toestsp ] = ma_nieuw;
            ma_toest [ ma_toestsp ++ ] = ma_actie;
         }
         else
         {
              /* error  */
            int ma_index [ MA_MAXERROR ], ma_nieuwtoest [MA_MAXERROR ];
            int ma_tel;
            int ma_coderror = CODERROR;

#ifdef MA_DEBUG
            printf ("error ");
#endif
         ma_eeee:
            if ( ma_errortel == 0 )
               if ( MA_ERR () ) return 1;
            ma_tel = 0;
            for ( ma_errortel = ma_toestsp-1;ma_errortel >=0;ma_errortel --)
            {
               if ( ( ma_actie = ma_bepactie ( ma_toest[ma_errortel ],
                    & ma_coderror ) ) >= 0 && ma_actie != MA_ERRACT )
               {
                  ma_index [ma_tel]  = ma_errortel;
                  ma_nieuwtoest [ ma_tel ++ ] = ma_actie;
                  if ( ma_tel >= MA_MAXERROR - 1)
                     goto ma_stackoverfl;
               }
            }
            if ( ma_tel == 0 )
               return 1;
            ma_actie = -1;
            do
            {
               ma_errortel = 0;
               while ( ma_errortel < ma_tel &&
                       ( ma_actie < 0 || ma_actie == MA_ERRACT )  )
               {
                  ma_actie =
                     ma_bepactie ( ma_nieuwtoest [ ma_errortel],
                                    & ma_lookahead );
                  if ( ma_actie < 0 || ma_actie == MA_ERRACT )
                     ma_errortel ++;
               }
               if ( ma_errortel == ma_tel )
               {
                  if ( ma_lookahead != CODEIND )
                  {
                     ma_lookahead = CODNIL;
                  }
               }
            }
            while ( ma_errortel == ma_tel && ma_lookahead != CODEIND );
            if ( ma_errortel == ma_tel && ma_lookahead == CODEIND )
               return 1;

            ma_toestsp = ma_index [ ma_errortel ] + 1;
            ma_toest [ ma_toestsp ++ ] = ma_nieuwtoest [ ma_errortel ];
#ifdef MA_DEBUG
            printf ("herstel in S%d\n", ma_toest [ ma_toestsp - 1] );
#endif
            ma_errortel = 4;
         }
      }
   }
ma_stackoverfl:
   printf ("parse stack is vol\n");
   exit (0);
}


void ma_code ( teken)
int * teken;

{

   register int a = * teken;
#ifdef MA_LAAGSTECODE
   if ( a > MA_LAAGSTECODE + 1 && a < MA_HOOGSTECODE )
      * teken = MA_LAAGSTECODE - a;
   else
   {
      printf ("scanner geeft onbekend teken\n");
      * teken = 0;
   }
#else
   register int *p;

   p = ma_tekencodes;
   while ( * p )
   {
      if ( * p == a )
      {
         * teken = * ( p + 1);
         return;
      }
      p += 2;
   }
   printf ("scanner geeft onbekend teken\n");
   * teken = 0;
#endif
   return;
}



int ma_bepactie ( toest, teken )
int toest;
int * teken;
{
   register int  * p, *q;
   register int a, def;
#if MA_REDVOORUIT
   if ( * teken == CODNIL &&
        ma_toestind [ toest ] == ma_toestind [ toest + 1 ] &&
        ma_link [ toest ] < 0
      )
   {
      return  ma_def [ toest ];
   }
#endif
   if ( * teken == CODNIL )
   {
      * teken = MA_SCAN ();
#ifdef MA_DEBUG
      printf ("tek %d, ", * teken );
#endif
      ma_code ( teken );
   }
   a = * teken;
   def = ma_def [ toest ];
   while (1)
   {
      p = ma_acties + ma_toestind [ toest ];
      q = ma_acties + ma_toestind [ toest + 1 ];
      while ( p < q )
      {
         if ( * p == a )
         {
            a = * ( p + 1 );
            if ( a != MA_DEFACT )
               return a;
            else
               return def;
         }
         p += 2;
      }
      toest = ma_link [ toest ];
      if ( toest < 0 )
         return def;
   }
}

int ma_acties [] = 
{
-4,13,-5,12,-7,11,-9,10,-11,9,-13,8,
-14,7,-21,6,-22,5,-23,4,-38,3,-39,2,
-43,1,2,14,3,15,4,16,5,17,5,18,
5,19,5,20,5,21,5,22,5,23,8,24,
5,25,-4,26,6,27,-4,28,7,29,-9,30,
-2,MA_ACCACT,-45,31,4,32,-5,58,-6,57,-16,56,
-17,55,-18,54,-19,53,-20,52,-24,51,-25,50,
-26,49,-27,48,-28,47,-29,46,-30,45,-31,44,
-32,43,-33,42,-34,41,-35,40,-36,39,-37,38,
-38,37,-39,36,-40,35,-41,34,-42,33,-16,MA_DEFACT,
-17,MA_DEFACT,-18,MA_DEFACT,-19,MA_DEFACT,-20,MA_DEFACT,-16,MA_DEFACT,-15,59,
-12,60,-10,61,-15,62,-8,63,-15,64,-6,65,
5,66,9,67,5,68,5,69,5,70,5,71,
5,72,5,73,5,74,5,75,5,76,5,77,
5,78,5,79,5,80,5,81,5,82,5,83,
5,84,5,85,5,86,5,87,5,88,5,89,
5,90,5,91,5,92,8,93,6,94,5,95,
7,96,5,97,-10,99,-15,98,-42,33,-40,35,
-41,34,-5,MA_ERRACT,-6,MA_ERRACT,-24,MA_ERRACT,-25,MA_ERRACT,-26,MA_ERRACT,
-27,MA_ERRACT,-28,MA_ERRACT,-29,MA_ERRACT,-30,MA_ERRACT,-31,MA_ERRACT,-32,MA_ERRACT,
-33,MA_ERRACT,-34,MA_ERRACT,-35,MA_ERRACT,-36,MA_ERRACT,-37,MA_ERRACT,-20,52,
-19,53,5,100,0};

int ma_toestind [] = 
{
0,34,34,36,38,38,38,40,42,44,48,50,
54,58,60,62,66,66,118,118,118,128,130,130,
132,134,136,138,140,142,144,148,148,148,150,152,
154,156,158,160,162,164,166,168,170,172,174,176,
178,180,182,184,186,188,190,192,194,194,196,198,
200,200,200,202,204,206,208,208,212,214,214,214,
218,218,250,250,250,250,250,250,250,250,250,250,
250,250,250,250,250,252,252,254,254,254,254,254,
254,254,254,256,256,256,0};

int ma_link [] = 
{
-1,-1,0,0,-1,-1,0,0,0,0,0,-1,
-1,-1,-1,0,-1,-1,-1,-1,17,17,21,21,
-1,21,-1,-1,-1,-1,0,-1,-1,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,-1,0,0,9,
-1,-1,11,0,12,0,21,-1,-1,68,68,68,
71,20,73,73,73,73,73,73,73,73,73,73,
73,73,73,20,20,21,88,73,73,-1,-1,21,
-1,21,0,-1,21,0};

int ma_def [] = 
{
MA_ERRACT,-39,MA_ERRACT,MA_ERRACT,-43,-44,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,
-41,MA_ERRACT,MA_ERRACT,-3,MA_ERRACT,-6,-7,-29,-35,-34,-49,MA_ERRACT,MA_ERRACT,
-45,MA_ERRACT,-47,MA_ERRACT,MA_ERRACT,-2,-4,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,
MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,
MA_ERRACT,MA_ERRACT,MA_ERRACT,MA_ERRACT,-5,MA_ERRACT,MA_ERRACT,MA_ERRACT,-40,-38,MA_ERRACT,MA_ERRACT,MA_ERRACT,
MA_ERRACT,-51,MA_ERRACT,-8,-10,-9,-12,-11,-28,-27,-26,-25,
-24,-23,-22,-21,-20,-19,-18,-17,-14,-13,-30,-31,
-33,-32,-16,-15,-50,-46,-36,-48,-37,MA_ERRACT,-42,-52,
0};

int ma_regelnum [] =
{
0,53,2,3,4,5,6,7,8,9,10,11,12,
13,14,15,16,17,18,19,20,21,22,23,24,
25,26,27,28,29,30,31,32,33,34,35,36,
37,38,39,40,41,42,43,44,45,46,47,48,
49,50,51,52,0
};

int ma_linkerk [] = 
{
0,1,2,3,3,4,5,5,5,5,5,5,5,
5,5,5,5,5,5,5,5,5,5,5,5,
5,5,5,5,5,5,5,5,5,5,5,5,
5,5,5,5,5,5,5,5,6,6,7,7,
8,8,9,9,0
};

int ma_rklengtes [] = 
{
0,2,2,1,2,2,2,2,3,3,3,3,3,
3,3,3,3,3,3,3,3,3,3,3,3,
3,3,3,3,2,3,3,3,3,2,2,4,
4,3,1,3,1,4,1,1,1,3,1,3,
1,3,1,3,0
};

int ma_tekencodes [] =
{
TOK_EOF,-45,TOK_NOSPACE,-44,TOK_NIL,-43,TOK_POW,-42,TOK_DIVIDES,-41,
TOK_TIMES,-40,TOK_MINUS,-39,TOK_PLUS,-38,TOK_IN,-37,TOK_LESSLESSEQUALEQUAL,-36,
TOK_GREATERGREATEREQUALEQUAL,-35,TOK_LESSLESSEQUAL,-34,TOK_GREATERGREATEREQUAL,-33,TOK_LESSLESS,-32,TOK_GREATERGREATER,-31,
TOK_GREATEREQUAL,-30,TOK_LESSEQUAL,-29,TOK_NOTEQUALEQUAL,-28,TOK_NOTEQUAL,-27,TOK_EQUALEQUAL,-26,
TOK_REWRITES,-25,TOK_EQUAL,-24,TOK_TRUE,-23,TOK_FALSE,-22,TOK_NOT,-21,
TOK_AND,-20,TOK_OR,-19,TOK_IMPLIES,-18,TOK_EQUIV,-17,TOK_DOT,-16,
TOK_COMMA,-15,TOK_NECESSARY,-14,TOK_POSSIBLE,-13,TOK_RBRACKET,-12,TOK_LBRACKET,-11,
TOK_RPAR,-10,TOK_LPAR,-9,TOK_RSQBRACKET,-8,TOK_LSQBRACKET,-7,TOK_GREATER,-6,
TOK_LESS,-5,TOK_NAME,-4,MA_DEFAULT,-3,MA_EIND,-2,MA_ERROR,-1,
0,0,0
};

#line 868 "inoutput.m" 
/******************************************************************/
/*               the output functions:                            */
/******************************************************************/



/* only to be called from printstring.    */

static void printchar ( f, x )
bliksemfile *f;
int x;
{
int c;
char s [ MAXFILENAMELEN + 50 ];

if( (f -> rw) != FILE_WRITE )
errorwithoutline( "printstring: file not open for writing" );
c = putc( x, f -> handle );
if( c == EOF )
{
sprintf( s, "problems with writing into file %s", f -> name );
errorwithoutline( s );
} 
if( x == '\n' )
{
(f -> linenum) ++ ; 
(f -> linepos) = 0;
}
else
(f -> linepos) ++ ; 
}


/* print a string into a file: */  

void printstring( f, s )
bliksemfile *f;
char *s;
{
int length;

length = 0;
while( s [ length ] )
length ++ ;

if( (f -> linepos) + length > MAXLINEPOS )
{
printchar( f, '\n' ); 
printchar( f, ' ' );
printchar( f, ' ' );
}        
while( *s )
{
printchar( f, *s );
s ++ ; 
}
}


/* print a string into a file. The difference between       */
/* printstring( f, s ), and printstringnnl( f, s ) is       */
/* that printstring prints a newline when the string is     */
/* going to be on a position >= MAXLINEPOS. When printing   */
/* prolog-output there can be no whitespace before a (.     */


void printstringnnl( f, s )
bliksemfile *f;
char *s;
{
while( *s )
{
printchar( f, *s );
s ++ ; 
}
}



/* print a variable: */ 

static char nicevars [] = "XYZTUW"; 

void printvariable( f, x )
bliksemfile *f; 
int x;
{
char printedvar [20];

if( x >= 0 ) 
{
internalproblem( "Not a variable" );
}

x = -x;
x --; 

/* Now we have a positive integer 0 <= x <= ....         */

switch( prologoutput )
{
case 0:
case 1:
if( x < 6 )
{
printedvar [0] = nicevars [x];
printedvar [1] = 0;
} 
else
sprintf( printedvar, "V%d", x - 6 );
break;
case 2:
sprintf( printedvar, "vvvv_(%d)", x );
break;  
case 3:
sprintf( printedvar, "vvvv_%d", x ); 
break; 
default:
internalproblem( "incorrect value of prologoutput" );
} 
printstring( f, printedvar );
}


/* We try to be on the safe side.   */

static int allowedinprologname( x )
int x;
{
if( x >= 'a' && x <= 'z' )
return 1;
if( x >= 'A' && x <= 'Z' )
return 1;
if( x >= '0' && x <= '9' )
return 1;
return 0;
}


/* print a name:    */

void printname ( f, n )
bliksemfile *f; 
int n;
{
char *s;
int i;
int special;
char squoted [ MAXNAMELEN + 5 ];
int quote;

s = namespace + nametable [ n ]. string; 

/* Decide whether or not quotes are necessary, */
/* and what the quote will be.                 */

if( prologoutput )
{
special = 0; 
for( i = 0; s[i]; i ++ )
{
if( ! allowedinprologname( s[i] ))
special = 1; 
}
if( ! ( s[0] >= 'a' && s[0] <= 'z' ))
special = 1;
quote = '\'';
}
else
{
special = 0; 
for( i = 0; s[i]; i ++ ) 
{
if( ! allowedinname( s[i] ))
special = 1;
}
quote = '\"';
}
if( special )
{
for( i = 0; s[i]; i ++ )
{
squoted [ i + 1 ] = s[i];
}
squoted[0] = quote;
squoted[i+1] = quote;
squoted[i+2] = 0;
printstring( f, squoted );
}
else
printstring( f, s ); 
}


/* print an integer:                */ 

void printint( f, x )
bliksemfile *f;
int x;
{
char s [ 40 ];

sprintf( s, "%d", x );
printstring( f, s );
}


/* print an integer hexadecimal.    */

void printhex( f, x )
bliksemfile *f;
int x;
{
int k;
int i;
char s[10];
int m;

i = 0;
for( k = sizeof(int) * 2 - 1; k >= 0; k -- )
{
if( k == sizeof(int) - 1 )
s [ i ++ ] = '.';

m = x >> ( k * 4 );
m = m & 0X0F;
if( m >= 10 )
{
m -= 10;
s [ i ++ ] = 'A' + m;
}
else
{
s [ i ++ ] = '0' + m;
}
}
s[i] = '\0';
printstring( f, s );
}


void printnametable ( f )
bliksemfile *f; 
{
int i, k;

printstring( f, "The name table:\n\n" );
for( i = 0; i < freenametable; i ++ ) 
{
printname( f, i );
printstring( f, "  " ); 
}
printstring( f, "\n\n" ); 

#if 1 
printf("Name table:/n/n");   
for( i = 0; i < MAXHASHVALUE; i ++ ) 
{
if( hashindex [i] >= 0 )
{
printf("hashvalue %d:\n", i );
k = hashindex [i];
while( k >= 0 )
{
printf("   %d %s\n", k, namespace + nametable [k]. string );
k = nametable [k]. next;
}
}
}
#endif 
}



/* strings used in printing the operators: */ 

static char *operatorstrings [] = 
{
"{}", ".", "||", "&&",
"!", "&", "|", "->",
"<->",

"[]", "<>", "[]", "<>",
"=", "==>", 

"<", ">", "==", "<=",
">=", ">>", "<<",
">>=", "<<=", ">>==", "<<==",
":",

"+", "-", "*", "/", 
"^", "-", "+"

};


#define LEFTASSOC       (0X400)  
#define RIGHTASSOC      (0X800)
#define NOTASSOC        (0XC00)

/* an operator is leftassoc if it is able to defend its arguments   */
/* against right context of the same binding strength.              */
/* An operator is rightassoc if it is able to defend its arguments  */
/* against left context of the same binding strength.               */

static int operatorpriorities [] = 
{
0, 0, 0, 0,         /* irrelevant. */ 

80, 70 + LEFTASSOC, 60 + LEFTASSOC, 10 + RIGHTASSOC,  
50 + LEFTASSOC, 
10, 10, 10, 10,
100 + NOTASSOC, 100 + NOTASSOC, 

100 + NOTASSOC, 100 + NOTASSOC, 100 + NOTASSOC, 100 + NOTASSOC,  
100 + NOTASSOC, 100 + NOTASSOC, 100 + NOTASSOC,
100 + NOTASSOC, 100 + NOTASSOC, 100 + NOTASSOC, 100 + NOTASSOC, 
100 + NOTASSOC,

110 + LEFTASSOC, 110 + LEFTASSOC, 120 + LEFTASSOC, 120 + LEFTASSOC, 
130 + RIGHTASSOC, 140, 140

};



/* printtermcontext( f, term, left, right ) prints term into file f. */
/* It uses left and right to decide if it is necessary to            */
/* insert parentheses.                                               */


static void printtermcontext( f, term, left, right )
bliksemfile *f;
int term;
int left;
int right;
{
int operator;
int arity;
int i;
int pars;
int priority;

operator = termspace [ term ];
if( operator < 0 ) 
{
printvariable ( f, operator );
return;
}

if( operator >= freeoperators && operator >= OP_NONPRIMITIVE )
goto error;

if( operator == OP_DOT ) 
{
/* print a list. */

printstring( f, "{ " );
while( operator == OP_DOT )
{ 
printtermcontext( f, term + 1, 0, 0 ); 
term = termends [ term + 1 ];
operator = termspace [ term ]; 
if( operator == OP_DOT )
printstring( f, ", " );
else
printstring( f, " }");
}
if( operator != OP_NIL ) 
goto error; 
return;  
} 

if( arities [ operator ] == 0 )
{
if( operator >= OP_NONPRIMITIVE ) 
printname( f, operators [ operator ]. name );
else
printstring( f, operatorstrings [ operator ] );
return;
}

if( operator >= OP_NONPRIMITIVE )
{
/* print a simple functional term. */
/* We can be sure that the arity is greater than 0. */

printname( f, operators [ operator ]. name );
printstring( f, "( " );
arity = arities [ operator ]; 
term ++ ; 
for( i = 0; i < arity; i ++ ) 
{
printtermcontext( f, term, 0, 0 );
if( i + 1 < arity )
printstring( f,", " );
else
printstring( f, " )" );
term = termends [ term ];
}
return;
}
/* what remain are the predefined, non-zero arity operators. */

if( operator == OP_FORALL || operator == OP_EXISTS ) 
{
/* the quantifiers: */

pars = 0;
priority = operatorpriorities [ operator ] & 0X3FF; 
if( right >= priority )
pars = 1;

if( pars )
printstring( f, "( "); 

switch( operator )
{
case OP_FORALL: 
printstring( f, "[ " );
break;
case OP_EXISTS:
printstring( f, "< " );    
break;
}
printtermcontext( f, term + 1, 0, 0 );
term = termends [ term + 1 ];
while( termspace [ term ] == operator )
{  
/* try to combine equal quantifiers as in [ .., .., .. ] */ 
printstring( f, ", " );
printtermcontext( f, term + 1, 0, 0 );
term = termends [ term + 1 ];
}

switch( operator )
{
case OP_FORALL:  
printstring( f, " ] " );
break;
case OP_EXISTS:
printstring( f, " > " );
break;
}

if( pars )
printtermcontext( f, term, priority, 0 );
else
printtermcontext( f, term, priority, right );

if( pars )
printstring( f, " )");

return; 
}

if( arities [ operator ] == 1 )
{
/* unary operators: */

pars = 0;
priority = operatorpriorities [ operator ] & 0X3FF; 

if( right >= priority )
pars = 1;

if( pars )
printstring( f, "( ");

printstring( f, operatorstrings [ operator ] );
printstring( f, " " );

term ++ ; 
if( pars )
printtermcontext( f, term, priority, 0 );
else
printtermcontext( f, term, priority, right );

if( pars )
printstring( f, " )"); 
return; 
}

if( arities [ operator ] != 2 )
goto error; 

pars = 0;
priority = operatorpriorities [ operator ] & 0X3FF;

switch( operatorpriorities [ operator ] & 0XFC00 )
{
case LEFTASSOC:
if( left >= priority ) 
pars = 1; 
if( right > priority )
pars = 1;
break; 
case RIGHTASSOC:
if( left > priority )
pars = 1; 
if( right >= priority ) 
pars = 1;  
break; 
case NOTASSOC:
if( left >= priority )
pars = 1;
if( right >= priority ) 
pars = 1; 
break; 
default:
goto error; 
}

if( pars )
{
printstring( f, "( ");
printtermcontext( f, term + 1, 0, priority );
printstring( f, " " );
printstring( f, operatorstrings [ operator ] );
printstring( f, " " );
printtermcontext( f, termends [ term + 1 ], priority, 0 );
printstring( f, " )" );
}
else
{
printtermcontext( f, term + 1, left, priority );
printstring( f, " " );
printstring( f, operatorstrings [ operator ] );
printstring( f, " " );
printtermcontext( f, termends [ term + 1 ], priority, right );
}
return; 

error:
internalproblem( "there is a deep, deep problem" );
}


/* print a term in prolog readable format.             */
/* This is used when the flag prologoutput > 0.        */
/* We try to use TPTP-format.                          */


static void printprologterm( f, term )
bliksemfile *f;
int term;
{
int operator;
int i, ar;

operator = termspace [ term ];
ar = arities [ operator ];

/* Check for variable.           */

if( operator < 0 )
{
printvariable( f, operator );
return;
}

/* Check for list:                  */

if( operator == OP_NIL )
{
printstring( f, "[]" );
return;
}

if( operator == OP_DOT )
{
printstring( f, "[ " );
while( operator == OP_DOT )
{
printprologterm( f, term + 1 );
term = termends [ term + 1 ];
operator = termspace [ term ];
if( operator == OP_DOT )
printstring( f, ", " );
else
printstring( f, " ]" );
}
if( operator != OP_NIL )
internalproblem( "nil expected" );
return;
}

/* Check for first order operators. */

switch( operator )
{
case OP_FALSE:
printstring( f, "false" );
break; 
case OP_TRUE:
printstring( f, "true" );
break;
case OP_NOT:
printstring( f, "~( " );
printprologterm( f, term + 1 );
printstring( f, " )");
return;
case OP_AND:
case OP_OR:
case OP_IMPLIES:
case OP_EQUIV:
if( operator == OP_AND ) printstring( f, "&( " );
if( operator == OP_OR ) printstring( f, "|( " );
if( operator == OP_IMPLIES ) printstring( f, "=>( " );
if( operator == OP_EQUIV ) printstring( f, "<=>( " );

printprologterm( f, term + 1 );
printstring( f, ", " );
printprologterm( f, termends [ term + 1 ] );
printstring( f, " )" ); 
return;
case OP_FORALL:
case OP_EXISTS:
printstring( f, ":( ");
if( operator == OP_FORALL ) printstring( f, "!( " );
if( operator == OP_EXISTS ) printstring( f, "?( " );
printstring( f, "[ ");
printprologterm( f, term + 1 );
printstring( f, " ] ), " );
printprologterm( f, termends [ term + 1 ] );
printstring( f, " )");
return;
case OP_REWRITES:
case OP_EQUAL:
printstring( f, "=( ");
printprologterm( f, term + 1 );
printstring( f, ", " );
printprologterm( f, termends [ term + 1 ] );
printstring( f, " )" );
return; 
}

/* The default case. Print the operator.   */

if( operator >= OP_NONPRIMITIVE )
printname( f, operators [ operator ]. name );
else
printstring( f, operatorstrings [ operator ] );

if( ar > 0 )
{
printstringnnl( f, "( " );   /* It was prolog. Remember? */

term = term + 1;
for( i = 0; i < ar; i ++ )
{
printprologterm( f, term );
if( i < ar - 1 )
printstring( f, ", " );
else
printstring( f, " )" );
term = termends [ term ];
} 
}
}


/* print a term. */ 

void printterm( f, term )
bliksemfile *f;
int term;
{
if( prologoutput )
printprologterm( f, term );
else
printtermcontext( f, term, 0, 0 ); 
}
#line 1547 "inoutput.m" 
/* print a consecutive list of terms:                  */

void printtermlist( f, s, termstart, termend )
bliksemfile *f;
char *s;
int termstart;
int termend; 
{
int i;

if( prologoutput )
{
printstring( f, s ); 
printstring( f, "\n" );

if( termstart == termend )
printstring( f, "[]" );
else
{
printstring( f, "[\n   " );
for( i = termstart; i < termend; i = termends [i] )
{
if( i != termstart )
printstring( f, ",\n   " );
printterm( f, i );
}
printstring( f, "\n]");
}
printstring( f, " .\n\n" );
}
else
{
printstring( f, "\n" ); 
printstring( f, s );
printstring( f, "\n\n" );

for( i = termstart; i < termend; i = termends [i] )
{
printterm( f, i );
printstring( f, ".\n" );
}
}
}


/* print an operator:    */ 

void printoperator( f, op )
bliksemfile *f;
int op;
{
if( op < OP_NONPRIMITIVE ) 
printstring( f, operatorstrings [ op ] );
else
printname( f, operators [ op ]. name );
}


#if 0
/* Print the list of operators:   */

void printoperators( f )
bliksemfile *f;
{
int i;

printstring( f, "\n" );
printstring( f, "The names in the input: \n\n");

for( i = OP_NONPRIMITIVE; i < freeoperators; i ++ ) 
{
printoperator( f, i );
printstring( f, ": " );
printint( f, arities [i] );
printstring( f, ",    " ); 
}
printstring( f, "\n\n");
}
#endif

/*********************************************************************/
/*     initialize the file structures.                               */
/*********************************************************************/


void initinoutput ( argc, argv )
int argc;
char *argv [];
{
int i;

if( argc > 2 )
{
printf("\ntoo many arguments:\n\n");
for( i = 1; i < argc; i ++ )
printf("%s\n", argv [i] );
printf("\n");
exit(1); 
}

if( argc == 1 )
{ 
inputfile. handle = stdin; 
strcpy( inputfile. name, "STDIN" );
}
else
{
if( strlen( argv [1] ) > MAXFILENAMELEN - 4 ) 
{
printf( "\nfilename %s is too long!\n\n", argv [1] );
exit(1);
}

inputfile. handle = fopen( argv [1], "r" );
if( inputfile. handle == ( FILE* ) NULL ) 
{
printf( "\ncould not open inputfile %s\n\n", argv [1] );
exit(1);
}   
strcpy( inputfile. name, argv [1] );
}
inputfile. rw = FILE_READ;
inputfile. linenum = 1;
inputfile. linepos = 0;
inputfile. lookahead = ' ';

outputfile. handle = stdout;
strcpy( outputfile. name, "STDOUT" );
outputfile. rw = FILE_WRITE;
outputfile. linenum = 1;
outputfile. linepos = 0;
outputfile. lookahead = ' ';

for( i = 0; i < MAXHASHVALUE; i ++ ) 
hashindex [i] = -1;

freenamespace = 0;
freenametable = 0;

inittokens( );
initoperators( );

scanfile = &inputfile; 
}
